<?php
include_once("cls_object.php");
include_once("cls_project.php");
class OAIProvider{
	var $xw;
	var $repositoryname='CollectConcept';
	var $baseurl;
	var $protocolversion='2.0';
	var $earliesttimestamp;
	var $deletedrecord='no';
	var $granularity='YYYY-MM-DD';
	var $adminemail='info@collectconcept.de';
	var $request;
	var $response;
	var $record=array();
	var $responseerror=array();
	var $set=array();
	var $resumptiontoken='';
	var $limit=20;
	var $offset=0;
	var $from=0;
	var $until=0;
	var $allowedprefixes=array('oai_dc','mda_spectrum','museumdat');
	var $tokenpath='tokens';
	private $possibleverbs=array('GetRecord','Identify','ListIdentifiers','ListMetadataFormats','ListRecords','ListSets');
	private $possiblearguments=array('verb','metadataPrefix','identifier','from','until','set','resumptionToken','setSpec');
	private $sysrequest=array('PHPSESSID');
	
	function Identify(){
		$this->xw->startElement('Identify');
		$this->xw->writeElement('repositoryName',$this->repositoryname);
		$this->xw->writeElement('baseURL',$this->baseurl);
		$this->xw->writeElement('protocolVersion',$this->protocolversion);
		$this->xw->writeElement('earliestDatestamp',$this->earliesttimestamp);
		$this->xw->writeElement('deletedRecord',$this->deletedrecord);
		$this->xw->writeElement('granularity',$this->granularity);
		$this->xw->writeElement('adminEmail',$this->adminemail);
		$this->xw->endElement();
	}	
	
	function ListMetadataFormats(){
		$this->xw->startElement('ListMetadataFormats');
		foreach($this->allowedprefixes as $prefix){
			$this->xw->startElement('metadataFormat');
			$this->xw->writeElement('metadataPrefix',$prefix);
			$this->xw->endElement();
		}	
		$this->xw->endElement();
	}	
	
	function SetXMLResponse(){
		if(!isset($this->earliesttimestamp)) $this->earliesttimestamp=date('Y-m-d',time());
		$this->xw->openMemory();
		$this->xw->startDocument('1.0','UTF-8');
		$this->xw->SetIndent(true);
		$this->xw->startElement ('OAI-PMH');
		$this->xw->writeAttribute('xmlns','http://www.openarchives.org/OAI/2.0/');
		$this->xw->writeAttribute('xmlns:xsi','http://www.w3.org/2001/XMLSchema-instance');
        $this->xw->writeAttribute('xsi:schemaLocation','http://www.openarchives.org/OAI/2.0/ http://www.openarchives.org/OAI/2.0/OAI-PMH.xsd');
		$this->xw->writeElement('responseDate',date('Y-m-d\TH:i:s\Z',time()));
		$this->xw->startElement('request');

		#Check request variables
		foreach($this->request as $requestvar=>$requestvalue){
			#echo $requestvar;
			if(!in_array($requestvar,$this->sysrequest)){
			if(in_array($requestvar,$this->possiblearguments)){
				if(isset($this->request[$requestvar]))
					$this->xw->writeAttribute($requestvar,$this->request[$requestvar]);
			}
			#else $this->responseerror[]='badVerb';
			}
		}
		$this->xw->text($this->baseurl);
		$this->xw->endElement();
		if(isset($this->request["from"])){
			$chckfrom=date_parse($this->request["from"]);
			#print_r($chckfrom);
			if($chckfrom[error_count]>0){
		    	$this->responseerror[]='badArgument';
		    	$this->responseerrormessage[]='invalid date format: '.$this->request["from"];
			}
			else
			    $this->from=strtotime($this->request["from"]);
		}
 		if(isset($this->request["until"])){
			$chckuntil=date_parse($this->request["until"]);
			#print_r($chckfrom);
			if($chckuntil[error_count]>0){
		    	$this->responseerror[]='badArgument';
		    	$this->responseerrormessage[]='invalid date format: '.$this->request["until"];
			}
			else
			    $this->until=strtotime($this->request["until"]);
			if(isset($this->request["from"])&&strlen($this->request["from"])!=strlen($this->request["until"]))
				$this->responseerror[]='badArgument';
		}
		#if(!isset($this->request["metadataPrefix"]))$this->request["metadataPrefix"]='oai_dc';
		elseif(isset($this->request["metadataPrefix"])&&!in_array($this->request["metadataPrefix"],$this->allowedprefixes)){
			$this->responseerror[]='cannotDisseminateFormat';
			$this->responseerrormessage[]='selected XML format not supported';
		}
		$resumpt=$this->GetResumption();
		
		
		$setid="";
		if(isset($this->request["setSpec"])){
			$this->SetSets();
			$foundset=false;
			foreach($this->set as $sk=>$sets){
				if(is_numeric($this->request["setSpec"]))
					$theset=$sets["id"];
				else
					$theset=$sets["code"];
				if($this->request["setSpec"]==$theset){
				    $this->Set_id=$setid=$sets["id"];
				    $foundset=true;
				}
			}	
			if(!$foundset){
			$this->responseerror[]='noRecordsMatch';
			$this->responseerrormessage[]='Set not found';
			}
		}	
			

			
			#print_r($resumpt);
			if($resumpt===false){
				$this->responseerror[]='badResumptionToken';
				$this->responseerrormessage[]='Resumption token has wrong format';
				$this->responseerror[]='badArgument';
				$this->responseerrormessage[]='bad resumption token as argument';
			}
			elseif(sizeof($this->responseerror)==0){
				#getrecord
				if($this->request["verb"]=='ListSets')
				    $this->ListSets();
				elseif($this->request["verb"]=='GetRecord')
				    $this->GetRecord($this->request["identifier"]);
				#listrecords
		  		elseif($this->request["verb"]=='ListRecords')
				    $this->ListRecords($setid);
	   	  		elseif($this->request["verb"]=='ListIdentifiers')
				    $this->ListIdentifiers($setid);
			}

		#Send Error
		if(sizeof($this->responseerror)>0){
			foreach($this->responseerror as $ek=>$err){
				$this->xw->startElement('error');
				$this->xw->writeAttribute('code',$err);
				$this->xw->text($this->responseerrormessage[$ek]);
				$this->xw->endElement();
			}
		}
		elseif($this->request["verb"]=='Identify'){
			$this->Identify();
			#Send Identification
		}	
		elseif($this->request["verb"]=='ListMetadataFormats')
		    $this->ListMetadataFormats();
		$this->xw->endElement();
		#,);
		$sql="INSERT INTO OAI_LOG (LOG_TIME, REQUEST,HOST,ERRORS) values(".db::timestamp().",".db::varchar($_SERVER['QUERY_STRING']).",".db::varchar(gethostbyaddr($_SERVER['REMOTE_ADDR'])).",".db::varchar(implode(';',$this->responseerror)).")";
		$res=db::query($this->connect,$sql);
	}	
	
	function GetResumption(){
		if(!isset($this->request["resumptionToken"]))
      		$tokenvars=array();
		else{
		if(preg_match('!o:([0-9]+)[:\z]?!s',$this->request["resumptionToken"],$ofmatch))
			$tokenvars["offset"]=$ofmatch[1];
			if(is_numeric($ofmatch[1])) $this->offset=$ofmatch[1];
        if(preg_match('!f:([0-9]+)[:\z]?!s',$this->request["resumptionToken"],$sdmatch))
            $tokenvars["from"]=date('Y-m-d',$sdmatch[1]);
            if(is_numeric($sdmatch[1])&&$sdmatch[1]>0&&$sdmatch[1]<time())$this->from=$sdmatch[1];
        if(preg_match('!u:([0-9]+)[:\z]?!s',$this->request["resumptionToken"],$edmatch))
            $tokenvars["until"]=date('Y-m-d',$edmatch[1]);
            if(is_numeric($edmatch[1])&&$edmatch[1]>0&&$edmatch[1]<time())$this->until=$edmatch[1];
         if(preg_match('!m:([0-9]+)[:\z]?!s',$this->request["resumptionToken"],$metadmatch))
            $this->request["metadataPrefix"]=$tokenvars["meta"]=$this->allowedprefixes[$metadmatch[1]];
	 if(preg_match('!s:([0-9]+)[:\z]?!s',$this->request["resumptionToken"],$setdmatch))
            $this->request["setSpec"]=$tokenvars["set"]=$setdmatch[1];
		}
        if(isset($tokenvars))
			return $tokenvars;
		else
		    return false;
	}

	function SetResumptionToken(){
		$offset=$this->offset+$this->limit;
		$this->resumptiontoken='o:'.$offset;
		$this->resumptiontoken.=':f:'.$this->from;
		$this->resumptiontoken.=':u:'.$this->until;
		$this->resumptiontoken.=':m:'.array_search ($this->request["metadataPrefix"],$this->allowedprefixes);
		$this->resumptiontoken.=':s:'.$this->Set_id;
	}	

	
	function GetRecord($id){
		if(array_key_exists('identifier',$this->request)&&array_key_exists('metadataPrefix',$this->request)){
			if($record=$this->SetRecord($id,$this->request["metadataPrefix"])){
			$this->xw->startElement('GetRecord');
			$this->xw->startElement('record');
			$this->xw->startElement('header');
			$this->xw->writeElement('identifier',$this->request["identifier"]);
			$this->xw->writeElement('datestamp',$record["date"]);
			$this->xw->endElement();//header
			$this->xw->startElement('metadata');

			$this->xw->writeRaw($record["xml"]);
			$this->xw->endElement();//metadata
			$this->xw->endElement();
			$this->xw->endElement();
			}else{
			    $this->responseerror[]='idDoesNotExist';
			    $this->responseerrormessage[]='Unknown identifier';
			}
		}
		else{
		    $this->responseerror[]='badArgument';
		    $this->responseerrormessage[]='Identifier or metadataPrefix not defined';
		}
		#$this->record[$id]='<ab>bb</ab>';
	}
	
	function ListIdentifiers($setid=''){

		$objectids=$this->SetRecords($this->offset,$setid,$this->from,$this->until);
		if(sizeof($objectids)<$this->limit)
		    $this->resumptiontoken='';
		else{
			$this->SetResumptionToken();
		    
		}
		#print_r($objectids);
		if(sizeof($objectids)==0)
			$this->responseerror[]='noRecordsMatch';
		else{
			$this->xw->startElement('ListIdentifiers');
			foreach($objectids as $obid){
				if($record=$this->SetRecord($obid)){
					$this->xw->startElement('record');
					$this->xw->startElement('header');
					$this->xw->writeElement('identifier',$record["identifier"]);
					$this->xw->writeElement('datestamp',$record["date"]);
					$this->xw->endElement();//header
					$this->xw->endElement();
				}
			}
			if($this->resumptiontoken!='')
			    $this->xw->writeElement('resumptionToken',$this->resumptiontoken);
			$this->xw->endElement();
		}
	}	
	
	function ListRecords($setid=''){
		if(array_key_exists('metadataPrefix',$this->request)!==false){
			$objectids=$this->SetRecords($this->offset,$setid,$this->from,$this->until);
			if(sizeof($objectids)<$this->limit)
			    $this->resumptiontoken='';
			else{
				$this->SetResumptionToken();
			}
			if(sizeof($objectids)==0)
				$this->responseerror[]='noRecordsMatch';
			else{
				$this->xw->startElement('ListRecords');
				foreach($objectids as $obid){
					if($record=$this->SetRecord($obid,$this->request["metadataPrefix"])){
						$this->xw->startElement('record');
						$this->xw->startElement('header');
						$this->xw->writeElement('identifier',$record["identifier"]);
						$this->xw->writeElement('datestamp',$record["date"]);
						$this->xw->endElement();//header
						$this->xw->startElement('metadata');

						$this->xw->writeRaw($record["xml"]);
						$this->xw->endElement();//metadata
						$this->xw->endElement();
					}
				}
				if($this->resumptiontoken!='')
				    $this->xw->writeElement('resumptionToken',$this->resumptiontoken);
				$this->xw->endElement();
			}
		}
		else{
		    $this->responseerror[]='badArgument';
		    $this->responseerrormessage[]='Missing metadataPrefix';
		}
	}	
	
	function ListSets(){
		$this->SetSets(1);
		if(sizeof($this->set)>0){
			$this->xw->startElement('ListSets');
			foreach($this->set as $set){
				if($set["code"]!='')
					$this->xw->writeElement('setSpec',$set["code"]);
				else
					$this->xw->writeElement('setSpec',$set["id"]);
				$this->xw->writeElement('setName',utf8_encode($set["name"]));
			}
			$this->xw->endElement();
		}
		else{
		    $this->responseerror[]='noSetHierarchy';
		    $this->responseerrormessage[]='No sets defined';
		}
	}	
	
	function SetSets($status=1){
		$project=new project($this->connect);
		$projects=$project->getpublishedprojects(1);
		#print_r($projects);
		foreach($projects as $k=>$sets){
		    $this->set[$k]["id"]=$sets["id"];
		    $this->set[$k]["name"]=$sets["name"];
		    $this->set[$k]["code"]=$sets["code"];
		}
	}	
	
	
	################### the functions below need to be overwritten in order to retrieve your records...
	
	function SetRecords($offset,$setid="",$startdate=null, $enddate=null){
		if($startdate>0)
		    $startdate=date('Y-m-d',$startdate);
		else
		    $startdate=null;
		if($enddate>0)
		    $enddate=date('Y-m-d',$enddate);
		else
		    $enddate=null;
		$obj=new object($this->connect);
		$obids=$obj->getOAIobjects($startdate, $enddate,$offset,$this->limit, $setid);
		#$obids=$obj->searchobject("*",$offset,$this->limit,$setid,3);
		foreach($obids as $k=>$id)
		    $obids[$k]='oai:collectconcept.de:'.$id;
		return $obids;
	}		
	
	function SetRecord($id,$format='oai_dc',$createxml=true){
		$object=new object($this->connect);
		#urn:collectconcept:2:3345
			$object->objectid=substr (strrchr ($id, ":"), 1);

		if($object->setobjectdata()&&$object->status>=3){
			if($object->lastupdate=="")
			    $lastdate=$object->entrydate;
			else
			    $lastdate=$object->lastupdate;
			if($createxml==false)
			    return $record=array("date"=>date('Y-m-d',strtotime($lastdate)),"identifier"=>$id);
			else{
				if($format=='mda_spectrum')
			    	return $record=array("xml"=>$object->setSpectrumXML(),"date"=>date('Y-m-d',strtotime($lastdate)),"identifier"=>$id);
				elseif($format=='oai_dc')
					return $record=array("xml"=>$object->setTransformedXML(false,'schema/Ccspectrum.xsl'),"date"=>date('Y-m-d',strtotime($lastdate)),"identifier"=>$id);
                elseif($format=='museumdat')
					return $record=array("xml"=>$object->setTransformedXML(false,'schema/museumsdat.xsl'),"date"=>date('Y-m-d',strtotime($lastdate)),"identifier"=>$id);
				else
				    {
				    	return false;
					}
			}
		}
		else
		    return false;		
	}	
	##############################################
	
	function Response(){
		$xmlstring= $this->xw->outputMemory(true);
		header('Content-type: text/xml');
		echo $xmlstring;
	}
	
	function CheckIdentifier(){
		if(isset($this->request["identifier"])){
		if(strpos($this->request["identifier"],'oai:')===0)
			return true;
		else{
			$this->responseerror[]='badArgument';
			$this->responseerrormessage[]='Identifier has wrong format';
			return false;
			}
		}
		else
		    return false;
	}	
	
	function SetRequest($request){
		#print_r($request);
		$this->request=$request;
		$this->CheckIdentifier();
		$arguments=array_keys($request);
		foreach($arguments as $reqarg)
		    if(!in_array($reqarg,$this->possiblearguments)){
		    	$this->responseerror[]='badArgument';
		    	$this->responseerrormessage[]='Unknown argument 1 '.$reqarg;
		    	if($_REQUEST[$reqarg]==''){
		    		$this->responseerror[]='badVerb';
					$this->responseerrormessage[]='empty verb for '.$reqarg;
				}
			}
		if(isset($request["verb"])){
			if(!in_array($request["verb"],$this->possibleverbs)){
			    $this->responseerror[]='badVerb';
				$this->responseerrormessage[]='Unknown verb '.$request["verb"];
			}
		}
		else{
			$this->responseerror[]='badVerb';
			$this->responseerrormessage[]='No verb was specified';
		}	
		#elseif(sizeof($this->responseerror)==0)
		#	$this->request=array('verb'=>'Identify');
	}	
	
	function OAIProvider(){
		$this->xw = $w=new xmlWriter();
        if(!file_exists($this->tokenpath))
		    mkdir($this->tokenpath);
		$this->baseurl='http://'.$_SERVER["SERVER_NAME"].''.$_SERVER['PHP_SELF'];
	}
	
	function SetDBConnection($connect){
		$this->connect=$connect;
	}	
}	
?>
